<template>
  <div v-loading="loading">
    <el-form ref="ruleForm" :inline="true" :model="ruleForm" :rules="rules" label-width="100px">
      <el-form-item label="按钮名称" prop="name">
        <el-input v-model="ruleForm.name" placeholder="请输入按钮名称"/>
      </el-form-item>
      <el-form-item label="按钮编号" prop="code">
        <el-input v-model="ruleForm.code" placeholder="请输入按钮编号"/>
      </el-form-item>
      <el-form-item label="按钮链接地址" prop="url">
        <el-input v-model="ruleForm.url" placeholder="请输入按钮链接地址"/>
      </el-form-item>
      <el-form-item label="排序编号" prop="sort">
        <el-input v-model="ruleForm.sort" placeholder="请输入排序编号"/>
      </el-form-item>
      <el-form-item label="是否启用" prop="flag">
        <el-switch v-model="ruleForm.flag" active-value="1" inactive-value="0"/>
      </el-form-item>
      <el-form-item label="按钮描述" prop="remark" style="width: 100%;">
        <el-input v-model="ruleForm.remark" type="textarea" autosize placeholder="请输入按钮描述"/>
      </el-form-item>
      <el-form-item style="width: 100%; text-align: center;">
        <el-button type="primary" @click="submitForm">保存</el-button>
        <el-button @click="resetForm">重置</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>

<script>
import {
  addBtn,
  getBtn,
  editBtn
} from '@/api/systemSetup/roleSetting/menuSetup'
import { validateSort } from '@/utils/validate'
import { filterContent } from '@/utils'

const validateSortRule = (rule, value, callback) => {
  if (!validateSort(value)) {
    callback(new Error('请输入有效的排序编号（正整数、负整数、0）'))
  } else {
    callback()
  }
}

export default {
  name: 'AddOrEditBtn',
  props: {
    rowid: {
      type: Number,
      default: 0
    },
    moduleid: {
      type: Number,
      default: 0
    },
    layerid: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      ruleForm: {
        id: '', // 为空或null表示需要添加，有数值表示需要更新
        moduleid: this.moduleid, // 菜单id
        name: '', // 按钮名称
        code: '', // string	编码
        // jsevent: '',//事件
        url: '', // 后端使用的配置项
        // icon: $('#btnIcon').val(),//图标
        sort: '0', // 排序字段默认为1
        flag: '1', // 表示是否有效 无效0 有效1 删除2
        remark: '' // 备注信息
      },
      rules: {
        sort: [{
          required: false,
          trigger: 'blur',
          validator: validateSortRule
        }],
        name: [{
          required: true,
          trigger: 'blur',
          message: '请输入按钮名称',
        }],
        code: [{
          required: true,
          trigger: 'blur',
          message: '请输入按钮编号',
        }],
      },
      loading: false
    }
  },
  created() {
    if (this.rowid) {
      this.ruleForm.id = this.rowid
      this.getDetail(this.rowid)
    }
  },
  methods: {
    submitForm() {
      this.$refs.ruleForm.validate((valid) => {
        if (valid) {
          this.loading = true
          this.ruleForm.remark = filterContent.delHtmlTag(this.ruleForm.remark)
          // 添加
          if (!this.rowid) {
            addBtn(this.ruleForm).then(response => {
              this.loading = false
              if (response.state.toLowerCase() === 'success') {
                this.$parent.$layer.close(this.layerid)
                this.$parent.getList() // 重新加载父级数据
                this.$message.success('恭喜你，按钮信息添加成功!')
              }
            }).catch(() => {
              this.loading = false
            })
            return
          }
          // 编辑
          editBtn(this.ruleForm).then(response => {
            this.loading = false
            if (response.state.toLowerCase() === 'success') {
              this.$parent.$layer.close(this.layerid)
              this.$parent.getList() // 重新加载父级数据
              this.$message.success('恭喜你，按钮信息编辑成功!')
            }
          }).catch(() => {
            this.loading = false
          })
        } else {
          this.$message.error('请输入有效的必填项信息!')
          return false
        }
      })
    },
    resetForm() {
      this.$refs.ruleForm.resetFields()
    },
    // 获取按钮详情
    getDetail(rid) {
      console.log("123123123")
      getBtn(rid).then(response => {
        if (response.state.toLowerCase() === 'success') {
          const res = response.data
          this.ruleForm = {
            id: rid, // 为空或null表示需要添加，有数值表示需要更新
            moduleid: this.moduleid, // 菜单id
            name: res.name, // 按钮名称
            code: res.code, // string	编码
            // jsevent: res.jsevent,//事件
            url: res.url, // 后端使用的配置项
            // icon: res.icon,//图标
            sort: res.sort, // 排序字段默认为1
            flag: res.flag.toString(), // 表示是否有效 无效0 有效1 删除2
            remark: res.remark // 备注信息
          }
        }
      })
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>

</style>
